package crypto

// NoOpCrypter does not perform any encryption or decryption
// but rather just passes the value through. This is extremely
// useful for testcases so you don't have to encrypt/decrypt data
// for the test cases to work
type NoOpCrypter struct {
}

func (n NoOpCrypter) Encrypt(plaintext string) (string, error) {
	return plaintext, nil
}

func (n NoOpCrypter) Decrypt(ciphertext string) (string, error) {
	return ciphertext, nil
}
