package crypto

import "strings"

type NoOpHasher struct {
}

func (n NoOpHasher) Hash(pw string) (string, error) {
	return pw, nil
}

func (n NoOpHasher) Verify(pw, hash string) (bool, error) {
	return strings.EqualFold(pw, hash), nil
}

func (n NoOpHasher) Identify(string) string {
	return "no-op-hasher"
}
