package crypto

import (
	"crypto/rand"
	"errors"
)

var ErrRandomByteMismatch = errors.New("crypto: unexpected number of random bytes")

func randomBytes(count int) ([]byte, error) {
	bytes := make([]byte, count)
	n, err := rand.Read(bytes)
	if err != nil {
		return nil, err
	}
	if n != count {
		return nil, ErrRandomByteMismatch
	}
	return bytes, nil
}
